"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = currentDirName;

function _path() {
  const data = _interopRequireDefault(require("path"));

  _path = function () {
    return data;
  };

  return data;
}

/**
 * get the current working dir name.
 * @name currentDirName
 * @returns {string} current working dir name
 * @example
 * ```js
 *  currentDirName() // => 'bit'
 * ```
 */
function currentDirName() {
  const currentDir = process.cwd();
  return _path().default.basename(currentDir);
}